#include <iostream>
#include "ParenChecker.h"
using namespace std;

// Svaki ParenChecker ima svoj Stack
ParenChecker::ParenChecker(Stack* stack) {
	this->stack = stack;
}

// Metoda koja proverava da li su u ulaznom stringu 'input' sve zagrade dobro uparene
bool ParenChecker::getCheck(string input) {
	// Promenljiva koja pamti ID otvorenih zagrada
	int parenID = 1;
	// Promenljiva u koju cemo smestati ID zatvorenih zagrada
	int poppedID = 0;
	// Vrtimo se kroz ceo string (length() metoda dohvata broj znakova u stringu)
	for (unsigned i = 0; i < input.length(); i++) {
		// Ukoliko je ulazni znak otvorena zagrada, stavljamo njen ID na stek
		if (input[i] == '(') {
			// Ukoliko je operacija neuspesna, izlazimo iz metoda i vracamo false
			if (stack->push(parenID) == false) {
				return false;
			}
			cout << parenID++;
		}
		// Ukoliko je ulazni znak zatvorena zagrada, skidamo njen ID sa steka, odnosno uparujemo je sa poslednjom otvorenom zagradom
		else if (input[i] == ')') {
			// Nakon poziva metode 'pop', u promenljivoj poppedID ce biti smesten ID otvorene zagrade sa kojom smo uparili tekucu zatvorenu zagradu
			if (stack->pop(&poppedID) == false) {
				return false;
			}
			cout << poppedID;
		}
	}
	// Ako po zavrsetku obrade imamo prazan stek, znaci da smo uparili sve zagrade
	// Ukoliko stek nije prazan, ostala nam je jedna ili vise neuparenih zagrada
	// Stoga, uspesnost metode 'getCheck' zavisi od toga da li je stek prazan ili nije, pa nam taj indikator sluzi i kao povratna vrednost
	return stack->isEmpty();
}
