#include "Stack.h"
#include <iostream>
using namespace std;

// SP ukazuje na nulti element steka kao prvu praznu lokaciju za smestanje elemenata
Stack::Stack() {
	this->sp = 0;
}

bool Stack::push(int in) {
	// Ukoliko smo dosli do poslednjeg clana u steku, i nemamo vise mesta, ispisujemo gresku i vracamo 'false' kao oznaku neuspesne operacije
	if (this->sp == MaxStackSize) {
		cout << "Greska: Stek je pun." << endl;
		return false;
	}
	// U suprotnom na mesto gde ukazuje SP postavljamo novi broj 'in', a SP uvecavamo za jedan da bi pokazivao na novu slobodnu lokaciju
	stack[this->sp] = in;
	this->sp++;
	return true;
}

bool Stack::pop(int* out) {
	// Ukoliko SP ukazuje na nultu lokaciju, stek je prazan i nemamo sta da izvadimo iz njega, cime se javlja greska
	if (this->sp == 0) {
		cout << "Greska: Stek je prazan." << endl;
		return false;
	}
	// U suprotnom, dekrementiramo SP, sa nove pozicije SP-a skidamo broj iz steka i smestamo ga u memorijsku lokaciju na koju ukazuje pokazivac 'out'
	this->sp--;
	*out = stack[this->sp];
	return true;
}

bool Stack::isEmpty() {
	// Stek je prazan ukoliko SP ukazuje na nulti element u nizu.
	return this->sp == 0;
}