#ifndef STACK_H
#define STACK_H

// Imenovana konstanta - bolje od #define jer je #define preprocesorska direktiva, a imenovane konstante direktno obradjuje prevodilac
// Zbog navedenog, greske prilikom prevodjenja ce biti jasnije uz koriscenje konstanti
// Vise o konstantama bice u nastavku kursa
const int MaxStackSize = 256;

class Stack {
public:
	Stack();

	// Operacije stavljanja podatka u stek i vadjenja podatka iz steka 
	// Povratne vrednosti su oznake uspesnosti operacije
	bool push(int in);
	bool pop(int* out);
	// Parametar 'out' prihvatamo kao pokazivac kako bismo mogli da smestimo rezultat
	// u memorijsku lokaciju na koju pokazuje. Na taj nacin mozemo 'spolja' da vidimo promene nad tom lokacijom.
	/*  Primer:
		---------------

		---------------
	out		0x1000
		---------------
			.......
		---------------
	arg		  20		0x1000
		---------------
						0x1004
		---------------
	*/
	
	// Metoda koja ispituje da li je stek prazan
	bool isEmpty();

private:
	// SP = Stack Pointer - indeks elementa u steku do kojeg smo stigli sa popunjavanjem - ukazuje na prvu narednu slobodnu lokaciju
	int sp;
	// implementacija steka preko statickog niza
	int stack[MaxStackSize];
};

#endif