#include "Complex.h"
#include <cmath>
#include <iostream>
using namespace std;

Complex::Complex(string var, int re, int im) {
	this->re = re;
	this->im = im;
	this->var = var;
}

int Complex::getReal() {
	return this->re;
}

int Complex::getImag() {
	return this->im;
}

double Complex::abs() {
	return sqrt(this->re * this->re + this->im * this->im);
}

double Complex::arg() {
	return im != 0 || re != 0 ? atan2(im, re) : 0;
}

// Ispis kompleksnog broja : format je "z = a + bi"
// Ispis vodi racuna o svim mogucim granicnim slucajevima
void Complex::print() {
	cout << var << " = ";
	if (re == 0 && im == 0) cout << "0";
	if (re != 0) cout << re;
	if (im == 1 || im == -1) cout << (im > 0 && re != 0 ? "+" : "") << (im == 1 ? "i" : "-i");
	else if (im != 0) cout << (im > 0 && re != 0 ? "+" : "") << im << "i";
	cout << endl;
}

Complex* Complex::add(string var, Complex* z1, Complex* z2) {
	int re, im;
	re = z1->re + z2->re;
	im = z1->im + z2->im;
	return new Complex(var, re, im);
}

Complex* Complex::sub(string var, Complex* z1, Complex* z2) {
	int re, im;
	re = z1->re - z2->re;
	im = z1->im - z2->im;
	return new Complex(var, re, im);
}
