#ifndef COMPLEX_H
#define COMPLEX_H

#include <string>
using namespace std;

class Complex {
public:
	Complex(string var, int re, int im);

	int getReal();
	int getImag();

	// Metoda koja vraca apsolutnu vrednost kompleksnog broja
	double abs();
	// Metoda koja vraca argument kompleksnog broja
	double arg();

	// Metoda za ispis
	void print();

	// Metode koje sabiraju/oduzimaju dva kompleskna broja 'z1' i 'z2' i kreiraju nov kompleksan broj sa imenom 'var'
	static Complex* add(string var, Complex* z1, Complex* z2);
	static Complex* sub(string var, Complex* z1, Complex* z2);
	/*
		Staticke metode se pozivaju nad klasom a ne nad objektom.
		Da smo imali metodu: Complex* add(string var, Complex* z2); tada bi poziv metode izgledao ovako: z1->add("z", z2).
		z1 bi se preneo preko pokazivaca this, a z2 kao parametar funkcije.
		Na taj nacin ne tretiramo operande z1 i z2 na isti nacin (this je konstantan pokazivac, a z2 je nekonstantan pokazivac)
		Bolje je da se oba operanda tretiraju na isti nacin i salju kao argumenti metode.
		To se postize statickim metodama. Takve metode se pozivaju nad klasom i samim tim nemaju pokazivac 'this', sto znaci da metodu mozemo pozvati kad god zelimo bez potrebe za objektom konkretne klase.
		Poziv izgleda ovako: Complex::add("z", z1, z2);
	*/

private:
	int re, im;
	string var;
};

#endif
